{ lib, config, ... }:
{
  options = {
    hyprpaper.wallpaper = lib.mkOption {
      description = "Path to the wallpaper that should be used";
      default = "";
    };
  };

  config = {
    xdg.configFile."hypr/hyprpaper.conf".text =
      # if builtins.pathExists config.hyprpaper.wallpaper then
      if config.stylix.enable then
        "
        preload = ${config.stylix.image}
        wallpaper = ,${config.stylix.image}
        "
      else "";
    services.hyprpaper.enable = true;
  };
}
