{ device ? throw "Set this to your disk device, e.g. /dev/sda"
, swap-size ? "0"
, encrypted ? false
, lib
, ...
}:
let
  disko-luks = import ../modules/disko/disko-luks.nix;
in
{
  disko.devices.disk = lib.mergeAttrsList [
    { main = disko-luks.devices.disk.main; }
    {
      hdd = { 
        device = "/dev/sda";
        type = "disk";
        content = {
          type = "gpt";
          partitions = {
            main = {
              size = "100%";

            };
          };
        };
      };
    }
  ];
}
