{ config, pkgs, lib, inputs, ... }:

{
  imports = [
    inputs.nixvim.homeManagerModules.default

    ./plugins/lualine.nix
    ./plugins/undotree.nix
    ./plugins/telescope.nix
    ./plugins/lsp.nix
    ./plugins/lsp-lines.nix
   ./plugins/cmp.nix
    ./plugins/wilder.nix
    ./plugins/nvim-ts-comment-context.nix
    ./plugins/treesitter.nix
    ./plugins/vimtex.nix
    # ./plugins/neorg.nix
    # ./plugins/image.nix
    # ./plugins/treesitter.nix
    ./plugins/which-key.nix

    ./syntax/fsharp.nix

    ./extra.nix
    ./options.nix
    ./keymaps.nix
  ];

  programs.nixvim = {
    enable = true;

    # opts.performance.byteCompileLua = {
    #   enable = true;
    #   plugins = true;
    # };

    # colorschemes.nord.enable = true;
  };
}
