{ pkgs, ... }:
{
  xdg.configFile."nvim/syntax/fsharp.vim" =
    let
      git = pkgs.fetchFromGitHub {
        owner = "lulu-berlin";
        repo = "vim-fsharp";
        rev = "1afff075e0a1bcbedcc52881454b99f58ec5bbfc";
        sha256 = "sha256-tpEgCxZubyzz4z+JVep1R6F+mQidw/iAfRMTOF00v6U=";
      };
    in
    {
      source = "${git}/syntax/fsharp.vim";
    };
}
