{ pkgs, ... }:
{
  stylix.enable = true;
  # stylix.image = ./nixos-wallpaper.png;
  stylix.autoEnable = true;
  stylix.fonts = {
    serif = {
      package = pkgs.dejavu_fonts;
      name = "DejaVu Serif";
    };

    sansSerif = {
      package = pkgs.dejavu_fonts;
      name = "DejaVu Sans";
    };

    monospace = {
      # package = (pkgs.nerdfonts.override {
      #   fonts =
      #     [
      #       "Mononoki"
      #     ];
      # });
      package = pkgs.nerd-fonts.mononoki;
      name = "Mononoki Nerd Font";
    };

    emoji = {
      package = pkgs.noto-fonts-emoji;
      name = "Noto Color Emoji";
    };

  };
}
