{
  description = "Dotnet flake for dotnet development";
  outputs = { self, nixpkgs }:
    let
      pkgs = nixpkgs.legacyPackages.x86_64-linux;
    in
    {
      devShells.x86_64-linux = {
        default = with pkgs; mkShell {
          buildInputs = with pkgs; [
            dotnet-sdk_8
          ];

          shellHook = ''
            echo "dotnet shell"
          '';
        };
      };
    };
}
